/*
** Napser Protocol Header
*/

#ifndef INCL_NAPSTER_H
#define INCL_NAPSTER_H

#define NAP_SWAPIP(x) ( ((x&0xFF)<<24) | ((x&0xFF00)<<8) | ((x&0xFF0000)>>8) | (x>>24) )

extern unsigned long nap_sigmask;
extern char *nap_linktype[];

#define NAP_ERROR 0
#define NAP_LOGIN 2
#define NAP_LOGINRESP 3
#define NAP_LOGINALT 6
#define NAP_CREATEUSER 7
#define NAP_REGSUCCESS 8
#define NAP_REGUSED 9
#define NAP_NICKINVALID 10
#define NAP_NOTIFYSHARE 100
#define NAP_SEARCH 200
#define NAP_SEARCHRESULT 201
#define NAP_SEARCHCOMPLETE 202
#define NAP_FILEINFOREQ 203
#define NAP_FILEINFO 204
#define NAP_PRIVATEMSG 205
#define NAP_BROWSEUSER 211
#define NAP_BROWSERESULT 212
#define NAP_BROWSECOMPLETE 213
#define NAP_FILECOUNT 214
#define NAP_CHANNELJOIN 400
#define NAP_CHANNELPART 401
#define NAP_PUBLICMSGSEND 402
#define NAP_PUBLICMSGRECV 403
#define NAP_NOUSERCHANNEL 404
#define NAP_JOINACK 405
#define NAP_JOINMSG 406
#define NAP_USERPART 407
#define NAP_USERLIST 408
#define NAP_USERLISTEND 409
#define NAP_CHANNELTOPIC 410
#define NAP_ALTDLREQ 500
#define NAP_REMOTEQUEUEFULL 620
#define NAP_SYSMSG 621
#define NAP_EMAILCHANGE 702

typedef struct songdata_struct {
	char title[256];
	char chksum[40];
	unsigned long size;
	int bitrate,freq,time;
	char user[20];
	int link;
} *songdata, _songdata;


extern int nap_login(void);
extern void nap_logout(void);
extern int nap_listen(void);
extern void nap_search(char *keys, int max, int speed, int speedval, int bit, int bitval, int freq, int freqval);
extern void nap_request(songdata sd);
extern void nap_msg(char *nick, char *msg);
extern char *nap_getlinktype(int link);
extern void nap_browseuser(char *nick);
extern void nap_updateaccount(void);

#endif /* INCL_NAPSTER_H */
